﻿using Opc.Ua;
using OpcLabs.BaseLib.Instrumentation;
using OpcLabs.BaseLib.Security.Cryptography.PkiCertificates;
using OpcLabs.BaseLib.Security.KeyManagement.Internal;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Application;
using OpcLabs.EasyOpc.UA.Application.Extensions;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.EasyOpc.UA.Extensions;
using OpcLabs.EasyOpc.UA.Gds;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpc.UA.Toolkit.ClientServer;

class Program
{
   static void Main()
   {
      UAEndpointDescriptor endpointDescriptor = "opc.tcp://thederw10.bauercontrols.local:49321";
      endpointDescriptor.EndpointSelectionPolicy = new UAEndpointSelectionPolicy();

      // Hook static events
      EasyUAClient.LogEntry += EasyUAClientOnLogEntry;
      var config = new ApplicationConfiguration();
      try
      {
         // Set the application name, which determines the subject of the client certificate.
         // Note that this only works once in each host process


         // Do something - invoke an OPC read, to trigger some loggable entries.
         var client = new EasyUAClient();
         try
         {

            //   EasyUAClient.SharedParameters.EngineParameters.CertificateAcceptancePolicy.AcceptAnyCertificate = true;
            endpointDescriptor.EndpointSelectionPolicy.SecurityPolicyUriString = UASecurityPolicyUriStrings.Basic256;
            endpointDescriptor.EndpointSelectionPolicy.AllowedMessageSecurityModes = UAMessageSecurityModes.SecuritySignAndEncrypt;

            client.TestEndpoint(endpointDescriptor);
         }
         catch (UAException uaException)
         {
            Console.WriteLine("*** Failure: {0}", uaException.GetBaseException().Message);
         }

         // The certificate will be located or created in a directory similar to:
         // C:\ProgramData\OPC Foundation\CertificateStores\MachineDefault\certs
         // and its subject will be as given by the application name.

         Console.WriteLine("Processing log entry events for 10 seconds...");
         System.Threading.Thread.Sleep(10 * 1000);

         Console.WriteLine("Finished.");
      }
      finally
      {
         // Unhook static events
         EasyUAClient.LogEntry -= EasyUAClientOnLogEntry;
      }


      // Do not implicitly trust any endpoint URLs. We want the user be asked explicitly.

      // Define which server we will work with.
      //UAEndpointDescriptor endpointDescriptor = "opc.tcp://PLYDEMO.bauercontrols.local:49321";

      //// Instantiate the client object.
      //EasyUAClient client = new EasyUAClient();
      //// Instantiate the certificate management client object.
      //var certificateManagementClient = new EasyUACertificateManagementClient();
      //EasyUAClient.SharedParameters.EngineParameters.CertificateAcceptancePolicy.TrustedEndpointUrlStrings.Clear();
      //EasyUAClient.SharedParameters.EngineParameters.CertificateAcceptancePolicy.TrustedEndpointUrlStrings.Add("opc.tcp://PLYDEMO.bauercontrols.local:49320");
      //UACertificateGroupElementCollection certificateGroupElementCollection;

      //EasyUAApplication application = EasyUAApplication.Instance;
      //UAAttributeData attributeData;
      //try
      //{
      //   //certificateGroupElementCollection = certificateManagementClient.BrowseCertificateGroups(endpointDescriptor);
      //   EasyUAClient.SharedParameters.EngineParameters.CertificateAcceptancePolicy.AcceptAnyCertificate = true;


      //   endpointDescriptor.EndpointSelectionPolicy = new OpcLabs.EasyOpc.UA.Engine.UAEndpointSelectionPolicy();
      //   IPkiCertificate pkiCertificate = application.FindOwnCertificate();

      //   attributeData = client.Read(endpointDescriptor, "nsu=KEPServerEX ;ns=2;s=Channel1.Device1.Tag1");
      //   //we can add logic here to deny entry if cert is null/doesn't exist?
      //   var serverCert = endpointDescriptor.ServerCertificate;

      //   // (Optional) Add more security settings
      //}
      //catch (UAException uaException)
      //{
      //   Console.WriteLine("*** Failure: {0}", uaException.GetBaseException().Message);
      //   return;
      //}

      //// Display results.
      //Console.WriteLine("Value: {0}", attributeData.Value);
      //Console.WriteLine("ServerTimestamp: {0}", attributeData.ServerTimestamp);
      //Console.WriteLine("SourceTimestamp: {0}", attributeData.SourceTimestamp);
      //Console.WriteLine("StatusCode: {0}", attributeData.StatusCode);
      //Console.WriteLine("Certificate information:\n");

      //if (certificateGroupElementCollection.Count() <= 0)
      //{
      //   Console.WriteLine("No information found");
      //}

      //foreach (UACertificateGroupElement certificateGroupElement in certificateGroupElementCollection)
      //{
      //   Console.WriteLine(certificateGroupElement);
      //}

   }
   private static void EasyUAClientOnLogEntry(object sender, LogEntryEventArgs logEntryEventArgs)
   {
      if (logEntryEventArgs.EventId == 161)
         Console.WriteLine(logEntryEventArgs);
   }
}
